from rasax.community.services.settings_service import (
    SettingsService, default_stack_config, default_environments_config)

TEST_PROJECT = "test project"
TEST_TEAM = "test team"


def test_project_init(settings_service: SettingsService):
    settings_service.init_project(TEST_TEAM, TEST_PROJECT)

    actual = settings_service.get(TEST_TEAM, TEST_PROJECT)

    assert actual["config"] == default_stack_config()

    actual_env_config = settings_service.get_environments_config(TEST_PROJECT)

    assert actual_env_config == default_environments_config()


def test_save_config(settings_service: SettingsService):
    test_config = default_stack_config()
    test_config["extra"] = "extra value"

    settings_service.save_config(TEST_TEAM, TEST_PROJECT, test_config)

    actual = settings_service.get(TEST_TEAM, TEST_PROJECT)["config"]

    assert actual == test_config


def test_get_stack_services(settings_service: SettingsService):
    default_env = default_environments_config()["environments"]["stack"]

    actual = settings_service.stack_services(TEST_PROJECT)

    assert len(actual) == len(default_env)

    for k, v in default_env.items():
        assert actual[k].async_stack_endpoint.token == v["token"]
        assert actual[k].async_stack_endpoint.url == v["url"]
